Index: branches/StatisticalTesting/HeuristicLab.Analysis.Statistics/3.3/StatisticalTestingView.cs
===================================================================
--- branches/StatisticalTesting/HeuristicLab.Analysis.Statistics/3.3/StatisticalTestingView.cs	(revision 9954)
+++ branches/StatisticalTesting/HeuristicLab.Analysis.Statistics/3.3/StatisticalTestingView.cs	(revision 9957)
@@ -348,4 +348,6 @@
       }
 
+      double[][] newData = FilterDataForPairwiseTest(colIndex);
+
       double mwuBothtails;
       double mwuLefttail;
@@ -353,10 +355,8 @@
       int cnt = 0;
 
-      for (int i = 0; i < data.Length; i++) {
-        if (i != colIndex) {
-          alglib.mannwhitneyutest(data[colIndex], data[colIndex].Length, data[i], data[i].Length, out mwuBothtails, out mwuLefttail, out mwuRighttail);
-          if (mwuBothtails > significanceLevel) {
-            cnt++;
-          }
+      for (int i = 0; i < newData.Length; i++) {
+        alglib.mannwhitneyutest(data[colIndex], data[colIndex].Length, newData[i], newData[i].Length, out mwuBothtails, out mwuLefttail, out mwuRighttail);
+        if (mwuBothtails > significanceLevel) {
+          cnt++;
         }
       }
@@ -372,4 +372,33 @@
     }
 
+    private double[][] FilterDataForPairwiseTest(int columnToRemove) {
+      double[][] newData = new double[data.Length - 1][];
+
+      int i = 0;
+      int l = 0;
+      while (i < data.Length) {
+        if (i != columnToRemove) {
+          double[] row = new double[data[i].Length - 1];
+          newData[l] = row;
+
+          int j = 0, k = 0;
+          while (j < row.Length) {
+            if (i != columnToRemove) {
+              newData[l][j] = data[i][k];
+              j++;
+              k++;
+            } else {
+              k++;
+            }
+          }
+          i++;
+          l++;
+        } else {
+          i++;
+        }
+      }
+      return newData;
+    }
+
     private void CalculatePairwiseTestDetails(string groupName) {
       int colIndex = 0;
@@ -384,9 +413,13 @@
       }
 
+      double[][] newData = FilterDataForPairwiseTest(colIndex);
+
+      columnNames = columnNames.Where(x => x != groupName).ToList();
+
       var rowNames = new string[] { "p-Value of Mann-Whitney U", "Adjusted p-Value of Mann-Whitney U", 
             "p-Value of T-Test", "Adjusted p-Value of T-Test", "Necessary Sample Size for T-Test", "Cohen's d", "Hedges' g" };
 
-      DoubleMatrix pValsMatrix = new DoubleMatrix(rowNames.Length, stringConvertibleMatrixView.Content.Columns);
-      pValsMatrix.ColumnNames = stringConvertibleMatrixView.Content.ColumnNames;
+      DoubleMatrix pValsMatrix = new DoubleMatrix(rowNames.Length, columnNames.Count());
+      pValsMatrix.ColumnNames = columnNames;
       pValsMatrix.RowNames = rowNames;
 
@@ -395,15 +428,18 @@
       double mwuRighttail;
       double tTestLefttail;
-      double[] mwuPValues = new double[data.Length];
-      double[] tTestPValues = new double[data.Length];
+      double[] mwuPValues = new double[newData.Length];
+      double[] tTestPValues = new double[newData.Length];
       bool[] decision = null;
       double[] adjustedMwuPValues = null;
       double[] adjustedTtestPValues = null;
 
-      for (int i = 0; i < data.Length; i++) {
-        alglib.mannwhitneyutest(data[colIndex], data[colIndex].Length, data[i], data[i].Length, out mwuBothtails, out mwuLefttail, out mwuRighttail);
-        tTestLefttail = TTest.Test(data[colIndex], data[i]);
-        mwuPValues[i] = mwuBothtails;
-        tTestPValues[i] = tTestLefttail;
+      for (int i = 0; i < newData.Length; i++) {
+        if (i != colIndex) {
+          alglib.mannwhitneyutest(data[colIndex], data[colIndex].Length, newData[i], newData[i].Length, out mwuBothtails,
+            out mwuLefttail, out mwuRighttail);
+          tTestLefttail = TTest.Test(data[colIndex], newData[i]);
+          mwuPValues[i] = mwuBothtails;
+          tTestPValues[i] = tTestLefttail;
+        }
       }
 
@@ -411,12 +447,14 @@
       adjustedTtestPValues = BonferroniHolm.Calculate(significanceLevel, tTestPValues, out decision);
 
-      for (int i = 0; i < data.Length; i++) {
-        pValsMatrix[0, i] = mwuPValues[i];
-        pValsMatrix[1, i] = adjustedMwuPValues[i];
-        pValsMatrix[2, i] = tTestPValues[i];
-        pValsMatrix[3, i] = adjustedTtestPValues[i];
-        pValsMatrix[4, i] = TTest.GetOptimalSampleSize(data[colIndex], data[i]);
-        pValsMatrix[5, i] = SampleSizeDetermination.CalculateCohensD(data[colIndex], data[i]);
-        pValsMatrix[6, i] = SampleSizeDetermination.CalculateHedgesG(data[colIndex], data[i]);
+      for (int i = 0; i < newData.Length; i++) {
+        if (i != colIndex) {
+          pValsMatrix[0, i] = mwuPValues[i];
+          pValsMatrix[1, i] = adjustedMwuPValues[i];
+          pValsMatrix[2, i] = tTestPValues[i];
+          pValsMatrix[3, i] = adjustedTtestPValues[i];
+          pValsMatrix[4, i] = TTest.GetOptimalSampleSize(data[colIndex], newData[i]);
+          pValsMatrix[5, i] = SampleSizeDetermination.CalculateCohensD(data[colIndex], newData[i]);
+          pValsMatrix[6, i] = SampleSizeDetermination.CalculateHedgesG(data[colIndex], newData[i]);
+        }
       }
 
Index: branches/StatisticalTesting/HeuristicLab.Analysis.Statistics/3.3/StatisticalTestingView.designer.cs
===================================================================
--- branches/StatisticalTesting/HeuristicLab.Analysis.Statistics/3.3/StatisticalTestingView.designer.cs	(revision 9954)
+++ branches/StatisticalTesting/HeuristicLab.Analysis.Statistics/3.3/StatisticalTestingView.designer.cs	(revision 9957)
@@ -339,5 +339,5 @@
       this.allGroupTestGroupBox.TabIndex = 21;
       this.allGroupTestGroupBox.TabStop = false;
-      this.allGroupTestGroupBox.Text = "3. Equal Distributions Check using all Groups";
+      this.allGroupTestGroupBox.Text = "3. Kruskal Wallis Test for Inequalities in Distributions";
       // 
       // groupCompLabel
@@ -365,5 +365,5 @@
       this.normalityGroupBox.TabIndex = 20;
       this.normalityGroupBox.TabStop = false;
-      this.normalityGroupBox.Text = "2. Normal Distribution Check";
+      this.normalityGroupBox.Text = "2. Jarque-Bera Test for Normal Distribution";
       // 
       // label4