Index: stable/HeuristicLab.Data/3.3/HeuristicLab.Data-3.3.csproj
===================================================================
--- stable/HeuristicLab.Data/3.3/HeuristicLab.Data-3.3.csproj	(revision 9737)
+++ stable/HeuristicLab.Data/3.3/HeuristicLab.Data-3.3.csproj	(revision 9961)
@@ -117,4 +117,8 @@
     <Compile Include="Comparison.cs" />
     <Compile Include="ComparisonType.cs" />
+    <Compile Include="Path Types\DirectoryValue.cs" />
+    <Compile Include="Path Types\FileValue.cs" />
+    <Compile Include="Path Types\PathValue.cs" />
+    <Compile Include="Path Types\TextFileValue.cs" />
     <Compile Include="PercentMatrix.cs" />
     <Compile Include="PercentArray.cs" />
@@ -212,5 +216,5 @@
   -->
   <PropertyGroup>
-   <PreBuildEvent Condition=" '$(OS)' == 'Windows_NT' ">set Path=%25Path%25;$(ProjectDir);$(SolutionDir)
+    <PreBuildEvent Condition=" '$(OS)' == 'Windows_NT' ">set Path=%25Path%25;$(ProjectDir);$(SolutionDir)
 set ProjectDir=$(ProjectDir)
 set SolutionDir=$(SolutionDir)
@@ -219,5 +223,5 @@
 call PreBuildEvent.cmd
 </PreBuildEvent>
-<PreBuildEvent Condition=" '$(OS)' != 'Windows_NT' ">
+    <PreBuildEvent Condition=" '$(OS)' != 'Windows_NT' ">
 export ProjectDir=$(ProjectDir)
 export SolutionDir=$(SolutionDir)
Index: stable/HeuristicLab.Data/3.3/Path Types/DirectoryValue.cs
===================================================================
--- stable/HeuristicLab.Data/3.3/Path Types/DirectoryValue.cs	(revision 9961)
+++ stable/HeuristicLab.Data/3.3/Path Types/DirectoryValue.cs	(revision 9961)
@@ -0,0 +1,44 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.IO;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Data {
+  [Item("DirectoryValue", "Represents the path to a directory.")]
+  [StorableClass]
+  public class DirectoryValue : PathValue {
+    [StorableConstructor]
+    protected DirectoryValue(bool deserializing) : base(deserializing) { }
+    protected DirectoryValue(DirectoryValue original, Cloner cloner) : base(original, cloner) { }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new DirectoryValue(this, cloner);
+    }
+
+    public DirectoryValue() : base() { }
+
+    public override bool Exists() {
+      return Directory.Exists(Value);
+    }
+  }
+}
Index: stable/HeuristicLab.Data/3.3/Path Types/FileValue.cs
===================================================================
--- stable/HeuristicLab.Data/3.3/Path Types/FileValue.cs	(revision 9961)
+++ stable/HeuristicLab.Data/3.3/Path Types/FileValue.cs	(revision 9961)
@@ -0,0 +1,61 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.IO;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Data {
+  [Item("FileValue", "Represents the path to a file.")]
+  [StorableClass]
+  public class FileValue : PathValue {
+    [Storable]
+    private string fileDialogFilter;
+    public string FileDialogFilter {
+      get { return fileDialogFilter; }
+      set {
+        if (fileDialogFilter != value) {
+          fileDialogFilter = value;
+        }
+      }
+    }
+
+    [StorableConstructor]
+    protected FileValue(bool deserializing) : base(deserializing) { }
+    protected FileValue(FileValue original, Cloner cloner)
+      : base(original, cloner) {
+      fileDialogFilter = original.FileDialogFilter;
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new FileValue(this, cloner);
+    }
+
+    public FileValue()
+      : base() {
+      fileDialogFilter = @"All files|*.*";
+    }
+
+    public override bool Exists() {
+      return File.Exists(Value);
+    }
+  }
+}
Index: stable/HeuristicLab.Data/3.3/Path Types/PathValue.cs
===================================================================
--- stable/HeuristicLab.Data/3.3/Path Types/PathValue.cs	(revision 9961)
+++ stable/HeuristicLab.Data/3.3/Path Types/PathValue.cs	(revision 9961)
@@ -0,0 +1,58 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.IO;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Data {
+  [Item("PathValue", "Represents a path.")]
+  [StorableClass]
+  public abstract class PathValue : Item {
+
+    [Storable]
+    private readonly StringValue stringValue = new StringValue();
+    public StringValue StringValue {
+      get { return stringValue; }
+    }
+
+    public string Value {
+      get { return stringValue.Value; }
+      set {
+        if (value == null) value = string.Empty;
+        value = value.TrimEnd(Path.DirectorySeparatorChar, Path.AltDirectorySeparatorChar);
+        stringValue.Value = value;
+      }
+    }
+
+    [StorableConstructor]
+    protected PathValue(bool deserializing) : base(deserializing) { }
+    protected PathValue(PathValue original, Cloner cloner)
+      : base(original, cloner) {
+      stringValue = cloner.Clone(original.stringValue);
+    }
+
+    protected PathValue() : base() { }
+
+    public abstract bool Exists();
+  }
+}
Index: stable/HeuristicLab.Data/3.3/Path Types/TextFileValue.cs
===================================================================
--- stable/HeuristicLab.Data/3.3/Path Types/TextFileValue.cs	(revision 9961)
+++ stable/HeuristicLab.Data/3.3/Path Types/TextFileValue.cs	(revision 9961)
@@ -0,0 +1,43 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Data {
+  [Item("TextFile", "Represents the content and path to a text file.")]
+  [StorableClass]
+  public class TextFileValue : FileValue {
+    [StorableConstructor]
+    protected TextFileValue(bool deserializing) : base(deserializing) { }
+    protected TextFileValue(TextFileValue original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new TextFileValue(this, cloner);
+    }
+
+    public TextFileValue()
+      : base() {
+    }
+  }
+}